[![latest](https://img.shields.io/github/v/release/GyverLibs/GyverBlinker.svg?color=brightgreen)](https://github.com/GyverLibs/GyverBlinker/releases/latest/download/GyverBlinker.zip)
[![Foo](https://img.shields.io/badge/Website-AlexGyver.ru-blue.svg?style=flat-square)](https://alexgyver.ru/)
[![Foo](https://img.shields.io/badge/%E2%82%BD$%E2%82%AC%20%D0%9D%D0%B0%20%D0%BF%D0%B8%D0%B2%D0%BE-%D1%81%20%D1%80%D1%8B%D0%B1%D0%BA%D0%BE%D0%B9-orange.svg?style=flat-square)](https://alexgyver.ru/support_alex/)
[![Foo](https://img.shields.io/badge/README-ENGLISH-blueviolet.svg?style=flat-square)](https://github-com.translate.goog/GyverLibs/GyverBlinker?_x_tr_sl=ru&_x_tr_tl=en)  

[![Foo](https://img.shields.io/badge/ПОДПИСАТЬСЯ-НА%20ОБНОВЛЕНИЯ-brightgreen.svg?style=social&logo=telegram&color=blue)](https://t.me/GyverLibs)

# GyverBlinker
Таймер со счётчиком для мигания светодиодом и других задач
- Простыми словами: библиотека позволяет асинхронно мигнуть светодиодом несколько раз
- Асинхронная работа
- Установка количества срабатываний
- Установка активного и пассивного времени
- Два инструмента: VirtBlinker без привязки к пину и Blinker с указанием пина

### Совместимость
Все Arduino

## Содержание
- [Установка](#install)
- [Использование](#usage)
- [Пример](#example)
- [Версии](#versions)
- [Баги и обратная связь](#feedback)

<a id="install"></a>
## Установка
- Библиотеку можно найти по названию **GyverBlinker** и установить через менеджер библиотек в:
    - Arduino IDE
    - Arduino IDE v2
    - PlatformIO
- [Скачать библиотеку](https://github.com/GyverLibs/GyverBlinker/archive/refs/heads/main.zip) .zip архивом для ручной установки:
    - Распаковать и положить в *C:\Program Files (x86)\Arduino\libraries* (Windows x64)
    - Распаковать и положить в *C:\Program Files\Arduino\libraries* (Windows x32)
    - Распаковать и положить в *Документы/Arduino/libraries/*
    - (Arduino IDE) автоматическая установка из .zip: *Скетч/Подключить библиотеку/Добавить .ZIP библиотеку…* и указать скачанный архив
- Читай более подробную инструкцию по установке библиотек [здесь](https://alexgyver.ru/arduino-first/#%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0_%D0%B1%D0%B8%D0%B1%D0%BB%D0%B8%D0%BE%D1%82%D0%B5%D0%BA)
### Обновление
- Рекомендую всегда обновлять библиотеку: в новых версиях исправляются ошибки и баги, а также проводится оптимизация и добавляются новые фичи
- Через менеджер библиотек IDE: найти библиотеку как при установке и нажать "Обновить"
- Вручную: **удалить папку со старой версией**, а затем положить на её место новую. "Замену" делать нельзя: иногда в новых версиях удаляются файлы, которые останутся при замене и могут привести к ошибкам!

<a id="usage"></a>

## Использование
### VirtBlinker
```cpp
// конструктор
Blinker();
Blinker(uint8_t pin);

// начать мигание (количество, период вкл, период выкл)
void blink(int amount, uint16_t high, uint16_t low = 0);

void force();       // спровоцировать вызов ready
void stop();        // остановить мигание. Не спровоцирует вызов ready
bool state();       // статус выхода
bool ready();       // однократно вернёт true, когда мигание закончится
bool running();     // возвращает true, пока система мигает
uint16_t getLeft(); // получить остаток до следующего переключения в мс
uint8_t getLeft8(); // получить остаток до следующего переключения в диапазоне 0-255
bool tick();        // тикер, вызывать в loop. Однократно вернёт true при переключении состояния
```

### Blinker
```cpp
void init(uint8_t pin); // указать пин
void invert(bool inv);  // инвертировать выход
// + наследует все функции из VirtBlinker
```

<a id="example"></a>

## Пример
### Реальный
```cpp
#include <Blinker.h>
Blinker led(13);

void setup() {
  // мигнуть 5 раз, 700мс вкл, 400мс выкл
  led.blink(5, 700, 400);
}
void loop() {
  led.tick();
}
```

### Виртуальный
```cpp
#include <Blinker.h>
VirtBlinker blink;

void setup() {
  Serial.begin(115200);
  // мигнуть 5 раз, 700мс вкл, 400мс выкл
  blink.blink(5, 700, 400);
}
void loop() {
  if (blink.tick()) Serial.println(blink.state());
}
```

<a id="versions"></a>
## Версии
- v1.0

<a id="feedback"></a>
## Баги и обратная связь
При нахождении багов создавайте **Issue**, а лучше сразу пишите на почту [alex@alexgyver.ru](mailto:alex@alexgyver.ru)  
Библиотека открыта для доработки и ваших **Pull Request**'ов!

При сообщении о багах или некорректной работе библиотеки нужно обязательно указывать:
- Версия библиотеки
- Какой используется МК
- Версия SDK (для ESP)
- Версия Arduino IDE
- Корректно ли работают ли встроенные примеры, в которых используются функции и конструкции, приводящие к багу в вашем коде
- Какой код загружался, какая работа от него ожидалась и как он работает в реальности
- В идеале приложить минимальный код, в котором наблюдается баг. Не полотно из тысячи строк, а минимальный код